from typing import Optional

from CCLang_sly.Parser import Parser
from Interpreter.Validator import Validator
from CCLang_sly.Lexer import Lexer
from Interpreter.Repo import Repo
from Interpreter.Utils import Utils
from Models.AbstractSyntaxTree.AbstractSyntaxTree import AbstractSyntaxTree


class Interpreter:

    def __init__(self, repo: Repo, utils: Utils) -> None:
        self.__repo = repo
        self.__utils = utils
        # self.__lexer = Lexer(repo, utils)
        # self.__parser = Parser(repo, utils)
        # self.__validator = Validator(repo, utils)

    def interpret(self, line_str: str) -> None:
        """
        Interprets code line
        :param line_str:
        :return:
        """
        lexer = Lexer()
        parser = Parser()
        env = {}
        ast = parser.parse(lexer.tokenize(line_str))
        if ast is not None:
            print(ast)
