from sly import Parser as SlyParser

from CCLang_sly.Lexer import Lexer


class Parser(SlyParser):
    tokens = Lexer.tokens

    #precedence = (
    #    ('left', '+', '-'),
    #    ('left', '*', '/'),
    #    ('right', 'UMINUS'),
    #)

    def __init__(self):
        self.env = {}

    @_('')
    def statement(self, p):
        pass

    def error(self, p):
        print(f'ERROR: {p}')
        pass

    # lib definition
    @_('PUBLIC LIBRARY NAME LBRACE')
    def statement(self, p):
        return ('lib_def', p.NAME, True)

    @_('LIBRARY NAME LBRACE')
    def statement(self, p):
        return ('lib_def', p.NAME, False)

    # class definition
    @_('PUBLIC CLASS NAME LBRACE')
    def statement(self, p):
        return ('class_def', p.NAME, True)

    @_('CLASS NAME LBRACE')
    def statement(self, p):
        return ('class_def', p.NAME, False)

    # func definition
    @_('PUBLIC FUNCTION NAME LPARAN statement RPARAN COLON type LBRACE')
    def statement(self, p):
        return ('func_def', p.NAME, True)

    @_('FUNCTION NAME LPARAN RPARAN COLON type LBRACE')
    def statement(self, p):
        return ('func_def', p.NAME, False)

    # types
    @_('EMPTY')
    def type(self, p):
        return ('type', p.EMPTY)

    # right brace
    @_('RBRACE')
    def statement(self, p):
        return ('end', p.RBRACE)
