from cpl.application import ApplicationABC
from cpl.configuration import ConfigurationABC
from cpl.console import Console
from cpl.dependency_injection import ServiceProviderABC

from lexer.abc.lexer_abc import LexerABC


class Application(ApplicationABC):

    def __init__(self, config: ConfigurationABC, services: ServiceProviderABC):
        ApplicationABC.__init__(self, config, services)

        self._lexer: LexerABC = services.get_service(LexerABC)
        self._path = config.get_configuration('p')

    def _console(self): pass

    def _files(self): pass

    def configure(self):
        pass

    def main(self):
        Console.write_line(self._configuration.additional_arguments, self._path)
        if self._path is None:
            self._console()
            return

        self._files()
